//
//  AppCategoryViewController.swift
//  iAppsReview
//
//  Created by Kevin McNeish on 5/26/15.
//  Copyright (c) 2015 Oak Leaf Enterprises, Inc. All rights reserved.
//

import UIKit

protocol AppCategoryDelegate {
    
    func updateAppCategory(appCategoryEntity: AppCategoryEntity)
}

class AppCategoryViewController: UITableViewController {
    
    var appCategoryID: Int!
    var appCategory = AppCategory()
    var appCategoryList = Array<AppCategoryEntity>()
    var oldIndexPath: NSIndexPath?
    var delegate: AppCategoryDelegate!

    override func viewDidLoad() {
        super.viewDidLoad()

        self.appCategoryList = self.appCategory.getAllEntities()
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    // MARK: - Table view data source

    override func numberOfSectionsInTableView(tableView: UITableView) -> Int {
        // Return the number of sections.
        return 1
    }

    override func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        // Return the number of rows in the section.
        return self.appCategoryList.count
    }

    override func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell {
        
        let cell = tableView.dequeueReusableCellWithIdentifier("CategoryCell", forIndexPath: indexPath) as! UITableViewCell

        // Configure the cell...
        let categoryEntity = appCategoryList[indexPath.row]
        
        cell.textLabel?.text = categoryEntity.name
        
        // Check/uncheck the currently selected cell
        if categoryEntity.categoryID == self.appCategoryID {
            cell.accessoryType = UITableViewCellAccessoryType.Checkmark
            self.oldIndexPath = indexPath
        }
        else {
            cell.accessoryType = UITableViewCellAccessoryType.None
        }

        return cell
    }

    override func tableView(tableView: UITableView, didSelectRowAtIndexPath indexPath: NSIndexPath) {
        
        // Deselect the currently selected row
        self.tableView.deselectRowAtIndexPath(self.tableView.indexPathForSelectedRow()!, animated: false)
        
        // Uncheck the previously selected cell, check the currently selected cell
        if let iPath = oldIndexPath {
        	tableView.cellForRowAtIndexPath(iPath)?.accessoryType = UITableViewCellAccessoryType.None
        }
        
        tableView.cellForRowAtIndexPath(indexPath)?.accessoryType = UITableViewCellAccessoryType.Checkmark
        
        // Save the current index path for later
        self.oldIndexPath = indexPath
        
        // Call the protocol method on the delegate
        let categoryEntity = self.appCategoryList[indexPath.row]
        self.delegate.updateAppCategory(categoryEntity)
    }

}
